/*
 * Copyright (C) 2012 Technische Universitaet Muenchen
 * This file is part of the Sierpinski project. For conditions of distribution and
 * use, please see the copyright notice in the file 'copyright.txt' at the root
 * directory of this package and the copyright notice at http://www5.in.tum.de/sierpinski
 *
 *  Created on: Sep 1, 2012
 *      Author: Martin Schreiber <martin.schreiber@in.tum.de>
 */

#include "CDG_MatrixComputations_2D_Nodal_OnTheFly.hpp"
#include "CBasisFunctions2D.hpp"

/*
 * storage for matrices computed on program start for nodal basis
 */

CONFIG_DEFAULT_FLOATING_POINT_TYPE CDG_MatrixComputations_2D::timestep_mass_matrix[SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS][SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS];
CONFIG_DEFAULT_FLOATING_POINT_TYPE CDG_MatrixComputations_2D::timestep_inv_mass_matrix[SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS][SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS];
CONFIG_DEFAULT_FLOATING_POINT_TYPE CDG_MatrixComputations_2D::timestep_stiffness_u[SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS][SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS];
CONFIG_DEFAULT_FLOATING_POINT_TYPE CDG_MatrixComputations_2D::timestep_stiffness_v[SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS][SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS];

CONFIG_DEFAULT_FLOATING_POINT_TYPE CDG_MatrixComputations_2D::timestep_dofs_to_face[3][SIMULATION_HYPERBOLIC_NUMBER_OF_EDGE_DOFS][SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS];
CONFIG_DEFAULT_FLOATING_POINT_TYPE CDG_MatrixComputations_2D::timestep_fluxes_to_dofs[3][SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS][SIMULATION_HYPERBOLIC_NUMBER_OF_EDGE_DOFS];

CONFIG_DEFAULT_FLOATING_POINT_TYPE CDG_MatrixComputations_2D::adaptivity_refine_left[SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS][SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS];
CONFIG_DEFAULT_FLOATING_POINT_TYPE CDG_MatrixComputations_2D::adaptivity_refine_right[SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS][SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS];

CONFIG_DEFAULT_FLOATING_POINT_TYPE CDG_MatrixComputations_2D::adaptivity_coarsen_left[SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS][SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS];
CONFIG_DEFAULT_FLOATING_POINT_TYPE CDG_MatrixComputations_2D::adaptivity_coarsen_right[SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS][SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS];

CBasisFunctions2D<SIMULATION_HYPERBOLIC_NUMBER_OF_BASIS_FUNCTIONS, SIMULATION_HYPERBOLIC_BASIS_FUNCTIONS_DEGREE> CDG_MatrixComputations_2D::cBasisFunctions2D;


